/*
    Mohawk Software Framework by Mohawk Software
    Copyright (C) 1998-2001 Mark L. Woodward
 
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.
 
    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.
 
    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
    MA 02111-1307, USA
 
    If you want support or to commercially license this library, the author
    can be reached at info@mohawksoft.com
*/ 
#ifndef _CONFIG_

/** A configuration file, based on an AVL tree */
class MConfigFile : public MAVL
{
	protected:
	char *m_filename;

	virtual	void CritHandler(char *str);

	public:
	MConfigFile(void);
	MConfigFile(int argc, char **argv);
	virtual ~MConfigFile(void);
	char *	GetCfgFileName(void);
	char *	GetValue(char *name, char *def=NULL);
	int 	GetIntValue(char *name,int def);
	char *	GetCritValue(char *str);
	int 	GetCritIntValue(char *str);
};

/** field formatter */
class MFmt
{
	protected:
	typedef struct _tml
	{
		char *name;
		char *fmt;
	}TBL;

	MTArray	<TBL> m_tbl;
	char *m_szDefault;

	public:
	MFmt();
	~MFmt();
	void 	SetDefault(char *szDefault);
	char *	Get(int ndx);
	void 	Set(MConfigFile & cfg, int ndx, char *name);
	void 	Pump(MFile *f, int ndx, char *value);
};
/** SQL print formatter */
class MPrinter
{
	protected:
	MFmt		m_fmtField;
	MFmt		m_fmtBracket;
	MConfigFile 	m_cfg;
	Boolean 	m_fConfigured;
	MMutex		m_mutex;
	
	public:

	MPrinter( char *fname);
	MPrinter();
	~MPrinter();

	Boolean ReadConfig(char *filename);

	inline void SetBracket(int ndx, char *name)
	{ m_fmtBracket.Set(m_cfg, ndx, name); }
	inline char *GetBracket(int ndx)
	{ return m_fmtBracket.Get(ndx); }
	inline void SetBracketDefault(char *value)
	{ m_fmtBracket.SetDefault(value); }
	inline void PumpBracket(MFile *f, int ndx, char *value)
	{ m_fmtBracket.Pump(f,ndx,value); }

	inline void SetField(int ndx, char *name)
	{ m_fmtField.Set(m_cfg, ndx, name); }
	inline char *GetField(int ndx)
	{ return m_fmtField.Get(ndx); }
	inline void SetFieldDefault(char *value)
	{ m_fmtField.SetDefault(value); }
	inline void PumpField(MFile *f, int ndx, char *value)
	{ m_fmtField.Pump(f,ndx,value); }

	Boolean IsSet();
	void Close();
};
#endif
