/*
    Mohawk Software Framework by Mohawk Software
    Copyright (C) 1998-2001 Mark L. Woodward
 
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.
 
    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.
 
    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
    MA 02111-1307, USA
 
    If you want support or to commercially license this library, the author
    can be reached at info@mohawksoft.com
*/ 

#ifndef _METATBL_
#define _METATBL_

#define ESOUND_MASK	0x00100
#define OSOUND_MASK	0x00200
#define VARSON_MASK	0x00400
#define VOWEL_MASK	0x00800
#define ALNUM_MASK	0x01000
#define GNP_MASK	0x02000
#define IEY_MASK	0x04000
#define AO_MASK		0x08000
#define NK_MASK		0x10000
#define OY_MASK		0x20000
#define NH_MASK		0x40000
#define GN_MASK		0x80000

#define M_ESOUND(m)	(m & ESOUND_MASK)
#define M_OSOUND(m)	(m & OSOUND_MASK)
#define M_VARSON(m)	(m & VARSON_MASK)
#define M_VOWEL(m)	(m & VOWEL_MASK)
#define M_ALNUM(m)	(m & ALNUM_MASK)
#define M_GNP(m)	(m & GNP_MASK)
#define M_IEY(m)	(m & IEY_MASK)
#define M_AO(m)		(m & AO_MASK)
#define M_NK(m)		(m & NK_MASK)
#define M_OY(m)		(m & OY_MASK)
#define M_NH(m)		(m & NH_MASK)
#define M_GN(m)		(m & GN_MASK)

extern unsigned g_meta_tbl[];

#define META(c)		(g_meta_tbl[((unsigned char)(c))])

#endif

