/*
    Mohawk Software Framework by Mohawk Software
    Copyright (C) 1998-2001 Mark L. Woodward
 
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.
 
    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.
 
    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
    MA 02111-1307, USA
 
    If you want support or to commercially license this library, the author
    can be reached at info@mohawksoft.com
*/ 
#ifndef _MFKBD_
#define _MFKBD_

#ifdef UNISTD
#ifdef Linux
#include <termio.h>
#endif
#include <termios.h>
#include <curses.h>
#include <sys/file.h>
#include <sys/ioctl.h>
#endif
#ifdef Win32
#include <io.h>
#endif

/** A class to deal with keyboard I/O */
class MFKbd
{
#ifdef Linux
	static	struct termios 	s_iosave;
	static 	Boolean		s_open;	
	struct termios 		m_ionew;
	int			m_waiting;
#endif

	public:
	MFKbd(void);
	virtual ~MFKbd(void);

	/** Has a key been hit */
	Boolean	iskey(void);

	/** Get a key from terminal */
	int	get();
	/** Get a key from terminal, with echo */
	int	gete();
	/** Put a char to the terminal */
	void	put(int c);
	char 	*getst(char *buf, int cbmax);
	/** Get a string from terminal */
	char 	*getste(char *buf, int cbmax);
};

#endif
