/*
    Mohawk Software Framework by Mohawk Software
    Copyright (C) 1998-2001 Mark L. Woodward
 
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.
 
    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.
 
    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
    MA 02111-1307, USA
 
    If you want support or to commercially license this library, the author
    can be reached at info@mohawksoft.com
*/ 
#ifndef _MTOKEN_
#define _MTOKEN_

/** A class to split a string up into tokens.
Metaphone algorithm is not pure, it has been hacked to be
better for searching and less phonetically accurate.
*/
class MTokenize
{
	protected:
	unsigned char	m_tkntbl[256];
	unsigned char	m_tkntblends[256];
	unsigned char 	m_openQ;
	unsigned char	m_closeQ;
	Boolean		m_fMetaphone;
	
	virtual	Boolean SendToken(char *token, int cb);
	virtual Boolean HandleToken(char *token, int cb, char *raw)=0;

	public:
	MTokenize(char oq=0, char cq=0);
	virtual ~MTokenize();
	virtual int parse(char *string);
	virtual	void setchar(unsigned char c, unsigned char xlat);
	virtual	void setend(unsigned char c, unsigned char xlat);
	void SetMetaphone(Boolean fphone);
	void SetVowelphone(Boolean fphone);

};

#endif
