/*
    Mohawk Software Framework by Mohawk Software
    Copyright (C) 1998-2001 Mark L. Woodward
 
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.
 
    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.
 
    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
    MA 02111-1307, USA
 
    If you want support or to commercially license this library, the author
    can be reached at info@mohawksoft.com
*/ 
#include "Phoenix.h"
#ifndef _MWWW_
#define _MWWW_

#define MWWW_NOSOCK	-1
#define MWWW_NOCONNECT	-2
#define MWWW_NOREQ	-3
#define MWWW_NOWRITE	-4
#define MWWW_NODATA	-5
#define MWWW_SIZE	-6

#define MWWW_DEF_AGENT	"MFZilla"
#define MWWW_DEF_ACCEPT	"image/gif, image/x-xbitmap, image/jpeg, image/pjpeg, image/png, */*"
#define MWWW_DEF_LANG 	"en-us"
#define MWWW_DEF_CHAR	"iso-8859-1,*,utf-8"

class MWWW
{
	protected:
	struct timeval		m_start;
	struct timeval		m_stop;
	char		*	m_agent;
	char		*	m_accept;
	char		*	m_language;
	char 		*	m_charset;
	char		*	m_cookie;
	int			m_code;
	double			m_http;
	int			m_debug;

	virtual	void	progress(int);
	int 		WaitResponse(MSock *msock, int seconds);
	int 		ReadResponse(MSock *msock, MRandomFile *mf, char *buf, int cbbuf, int retries=10);
	int 		ParseCode(MRandomFile *mf, char *buf, int cbbuf);

	public:
	MWWW();
	int		Get(MRandomFile *mf, char *hostname, int port, char *url);
	int		Post(MRandomFile *mf, char *hostname, int port, char *url, char *postdata);
	void 		SetAgent(char *str);
	void 		SetAccept(char *str);
	void 		SetLanguage(char *str);
	void 		SetCharSet(char *str);
	void		SetCookie(char *cookie);
	void		SetDebug(int debug);
	int		GetCode(void);
	static 	int 	SplitURL(char *url, char *hostname, char *path, char *protocol);
};

#endif

